﻿/*
change_color_properties_for_startup.jsx
(c)2011 seuzo.jp
ドキュメントを開いた時にCMYKでないカラースペースや特色を検索し、修正します。

2011-09-09  ver 0.1 とりあえず
2011-09-11  ver.0.2 InDesign CS5のEventListenerでafterOpenイベントが２回呼ばれる問題を回避した。 http://d.hatena.ne.jp/seuzo/20110909/1315556790

*/

#target "InDesign"
#targetengine "change_color_properties"

(function(){

function change_color(my_event){
    if (app.documents.length === 0){return;}
    if ((parseInt(app.version) >= 7) &&
        (my_event.eventType === "afterOpen") &&
        (my_event.target instanceof LayoutWindow)){
        return;
    }

    var my_doc = app.documents[0];
    //var my_doc = my_event.parent;
    var my_colors = my_doc.colors;
    var my_space_cnt = 0; //Кол-во нарушений цветового пространства
    var my_model_cnt = 0; //カラーモデルの違反数（特色数） нарушения цветовой модели
    
    //InDesign CS5以上でドキュメントがWEB用に制作されている場合はアラートを出して中止
    if (parseInt(app.version) >= 7) {
        if (my_doc.documentPreferences.intent === DocumentIntentOptions.WEB_INTENT ) {
            alert("Этот документ сделан для интернета"); 
            return;
        }
    }
    
    //CMYK цветовое пространство
    for (var i =0; i < my_colors.length; i++) {
        if ((my_colors[i].hasOwnProperty("space")) 
        && (my_colors[i].space !== ColorSpace.CMYK)) {
            my_space_cnt++;
        }
    }
    //Изменение цветового пространства
    if (my_space_cnt > 0) {
        var my_space_ans = confirm("Цветов не CMYK " + my_space_cnt + " найдено\rПреобразовать в CMYK？");
        if (my_space_ans) {
            for (var i =0; i < my_colors.length; i++) {
                if ((my_colors[i].hasOwnProperty("space")) 
                && (my_colors[i].space !== ColorSpace.CMYK)) {
                    my_colors[i].space = ColorSpace.CMYK;
                }
            }
        }
    }
    
    //カラーモデルが特色ものを探す
    for (var i =0; i < my_colors.length; i++) {
        if ((my_colors[i].hasOwnProperty("model")) 
        && (my_colors[i].model === ColorModel.SPOT )) {
            my_model_cnt++;
        }
    }
    //Изменение цветовой модели
    if (my_model_cnt > 0) {
        var my_model_ans = confirm("Плашечных красок " + my_model_cnt + " найдено\rПреобразовать в триадные?");
        if (my_model_ans) {
            for (var i =0; i < my_colors.length; i++) {
                if ((my_colors[i].hasOwnProperty("model")) 
                && (my_colors[i].model === ColorModel.SPOT)) {
                    my_colors[i].model = ColorModel.PROCESS;
                }
            }
        }
    }
}//function change_color

    app.addEventListener("afterOpen", change_color, false);//ドキュメントを開いた後
    //app.addEventListener("afterImport", change_color, false);//読み込み後
    app.addEventListener("beforeSave", change_color, false);//保存前
})();